#include <AI8051U.H>
#include <intrins.h>
#include <absacc.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>

#define		MAIN_Fosc	24000000UL

#define		SS			P14
#define		LED0		P00
#define		LED1		P01
#define		LED2		P02
#define		LED3		P03
#define		LED4		P04
#define		LED5		P05
#define		LED6		P06
#define		LED7		P07

unsigned char xdata DMA_SPI_T_BUF[8] _at_ 0x0100;
unsigned char xdata DMA_SPI_R_BUF[8] _at_ 0x0200;
unsigned char xdata DMA_UR1R_BUF[8] _at_ 0x0300;

void delay_ms(unsigned char ms)
{
	unsigned int i;
	do
	{
		i=MAIN_Fosc/6000;
		while(--i);	//6T per loop
	}
	while(--ms);
}

void Init(void)
{
	WTST=0;					//óָʱֵΪ0ɽCPUִָٶΪ
	EAXFR=1;				//չĴ(XFR)ʹ
	CKCON=0;				//߷XRAMٶ
	
	IAP_TPS=24;
	USBCLK=0xA0;
	CLKSEL=0xC0;
	HSCLKDIV=0;
	SPI_CLKDIV=11;
	PWMA_CLKDIV=0;
	PWMB_CLKDIV=0;
	
	P0M1=0x00;	P0M0=0x00;	//Ϊ׼˫
	P1M1=0x00;	P1M0=0x00;	//Ϊ׼˫
	P2M1=0x00;	P2M0=0x00;	//Ϊ׼˫
	P3M1=0x00;	P3M0=0x00;	//Ϊ׼˫
	P4M1=0x00;	P4M0=0x00;	//Ϊ׼˫
	P5M1=0x00;	P5M0=0x00;	//Ϊ׼˫
	P6M1=0x00;	P6M0=0x00;	//Ϊ׼˫
	P7M1=0x00;	P7M0=0x00;	//Ϊ׼˫
	
	P0SR=0x00;				//Ϊ
	P1SR=0x00;				//Ϊ
	P2SR=0x00;				//Ϊ
	P3SR=0x00;				//Ϊ
	P4SR=0x00;				//Ϊ
	P5SR=0x00;				//Ϊ
	P6SR=0x00;				//Ϊ
	P7SR=0x00;				//Ϊ
	
//	SS=1;
	
	SCON = 0x50;		//8λ,ɱ䲨
	AUXR |= 0x01;		//1ѡʱ2Ϊʷ
	AUXR |= 0x04;		//ʱʱ1Tģʽ
	T2L = 0x8F;			//öʱʼֵ
	T2H = 0xFD;			//öʱʼֵ
	AUXR |= 0x10;		//ʱ2ʼʱ
	ES=1;				//ʹUART1ж
	
	SPCTL=0xF7;
	SPSTAT=0xC0;
	HSSPI_PSCR=0;
	HSSPI_CFG=0x00;
	HSSPI_CFG2=0x20;	//Ϊ0x30FIFOSPIû
	
	DMA_SPI_CFG=0xE0;
	DMA_SPI_CFG2=0x04;
	DMA_SPI_CR=0x81;
	DMA_SPI_STA=0x00;
	DMA_SPI_AMT=7;
	DMA_SPI_TXAH=0x01;
	DMA_SPI_TXAL=0x00;
	DMA_SPI_RXAH=0x02;
	DMA_SPI_RXAL=0x00;
	DMA_SPI_ITVH=0x00;
	DMA_SPI_ITVL=0x08;
	
	DMA_UR1R_CFG=0x80;
	DMA_UR1R_CR=0x81;
	DMA_UR1R_STA=0x00;
	DMA_UR1R_AMT=7;
	DMA_UR1R_RXAH=0x03;
	DMA_UR1R_RXAL=0x00;
	DMA_UR1_ITVH=0x00;
	DMA_UR1_ITVL=0x08;
	
	DMA_P2P_CR1=0x15;
	ESPI=1;
	EA=1;
	
	memset(DMA_SPI_T_BUF,0x00,sizeof DMA_SPI_T_BUF);
	memset(DMA_SPI_R_BUF,0x00,sizeof DMA_SPI_R_BUF);
	memset(DMA_UR1R_BUF,0x00,sizeof DMA_UR1R_BUF);
}

void main(void)
{
	unsigned char temp;
	Init();
	temp=~0x01;
	while(1)
	{
		temp=_crol_(temp,1);
		delay_ms(100);
		P2=temp;
//		SS=0;
//		SPDAT=0x5A;
//		DMA_SPI_T_BUF[0]=0x5A;
//		DMA_SPI_T_BUF[1]=0xA5;
//		DMA_SPI_T_BUF[2]=0x5A;
//		DMA_SPI_T_BUF[3]=0xA5;
//		DMA_SPI_T_BUF[4]=0x5A;
//		DMA_SPI_T_BUF[5]=0xA5;
//		DMA_SPI_T_BUF[6]=0x5A;
//		DMA_SPI_T_BUF[7]=0xA5;
//		DMA_SPI_CR=0xC1;
		
		DMA_UR1R_CR=0xA1;
//		DMA_SPI_CR=0xC1;
	}
}

void UART1_Isr(void) interrupt UART1_VECTOR
{
	if(RI)
	{
		RI=0;
		LED3=!LED3;
	}
	if(TI)
	{
		TI=0;
		
	}
}

void SPI_Isr(void) interrupt SPI_VECTOR
{
	SPSTAT|=0x80;
//	SS=1;
	LED0=!LED0;
}

void DMA_SPI_Isr(void) interrupt DMA_SPI_VECTOR
{
	DMA_SPI_STA&=~0x01;
	LED1=!LED1;
}

void DMA_UR1R_Isr(void) interrupt DMA_UR1R_VECTOR
{
	DMA_UR1R_STA&=~0x01;
	LED2=!LED2;
}